<?php

require_once __DIR__."/../vendor/autoload.php";

use NoccyLabs\PipeLink\Link;
use NoccyLabs\PipeLink\Message;

$process = proc_open("php process.php", [0=>['pipe','r'],1=>['pipe','w'],2=>STDERR], $pipes);
$processLink = Link::createFromPipes($pipes[1], $pipes[0]);

// Add a handler to process incoming messages
$processLink->addInputHandler(function (Message $message) use ($process) {

    if (!$message->hasAttribute("origin")) {
        $message->setAttribute("origin", "process");
    }

});

echo "Sending echo message...\n";
$processLink->sendMessage(new Message(type:"echo", body:"Hello World", msgId:"foobar"));
echo "Awaiting response...\n";
$message = $processLink->readMessage(true);
var_dump($message);

$processLink->sendMessage(new Message(type:"hash", body:['algo'=>"md5", 'data'=>"Hello World"], msgId:"foobaz"));
echo "Sending hash message...\n";
$message = $processLink->readMessage(true);
echo "Awaiting response...\n";
var_dump($message);
