<?php

require_once __DIR__."/../vendor/autoload.php";

use NoccyLabs\PipeLink\Link;
use NoccyLabs\PipeLink\Message;

// Create a link using the STDIN and STDOUT pipes
$uplink = Link::createFromPipes(STDIN,STDOUT);

$msg = $uplink->readMessage(true);

if ($msg->getType()=="echo") {
    $uplink->sendMessage(new Message(type:"echo.response", body:$msg->getBody(), responseToId:$msg->getMessageId()));
}

$msg = $uplink->readMessage(true);

if ($msg->getType()=="hash") {
    $result = [
        'hash' => hash($msg->get("algo"), $msg->get("data")),
        'algo' => $msg->get("algo")
    ];
    $uplink->sendMessage(new Message(type:"hash.result", body:$result, responseToId:$msg->getMessageId()));
}
