<?php

require_once __DIR__."/../vendor/autoload.php";

use NoccyLabs\PipeLink\Link;
use NoccyLabs\PipeLink\Message;

// Create a link using the STDIN and STDOUT pipes
$uplink = Link::createFromPipes(STDIN,STDOUT);

// Add output handler to process outgoing messages
$uplink->addOutputHandler(function (Message $message) {

    if ($message->getType() == "foo") {
        $message->setAttribute("numberSum", array_sum($message->get('numbers',[])));
    }

});

$uplink->sendMessage(new Message(type:"foo", body:[ "numbers" => [ 42, 420, 4200 ]]));

