<?php

namespace NoccyLabs\PipeLink;
use ArrayAccess;
use JsonSerializable;
use SplQueue;

class StreamLink extends Link implements LinkInterface
{

    private $input;

    private $output;

    private string $inputBuffer = '';

    public function __construct($input, $output)
    {
        $this->input = $input;
        $this->output = $output;
    }

    /**
     * {@inheritDoc}
     */
    public function update(): void
    {
        $r = [ $this->input ]; $w = $e = null;
        if (stream_select($r, $w, $e, 0)) {
            $this->inputBuffer .= fread($this->input, 65535);
        }
        while ($message = Message::unpack($this->inputBuffer)) {
            $this->pushInputMessage($message);
        }
    }

	/**
     * {@inheritDoc}
	 */
	protected function writeFrame(string $frame): void 
    {
        fwrite($this->output, $frame);
	}

}

