<?php

namespace NoccyLabs\PipeLink;



class MessageTest extends \PHPUnit\Framework\TestCase
{

    /**
     * @covers Message::pack
     */
    public function testPackingMessages()
    {
        $msg = new Message(type:"hello", body:null);
        $packed = $msg->pack();

        $this->assertEquals("\x00\x1c{\"type\":\"hello\",\"body\":null}", $packed);
    }

    /**
     * @covers Message::pack
     * @covers Message::unpack
     */
    public function testUnpackingMessages()
    {
        $msgA = new Message(type:"A", body:true);
        $msgB = new Message(type:"B", body:false, msgId:"test");
        $msgC = new Message(type:"C", body:null, responseToId:"test");
        $msgD = new Message(type:"D", body:"hello", attributes:["foo"=>42]);

        $buf = $msgA->pack().$msgB->pack().$msgC->pack().$msgD->pack();

        $readA = Message::unpack($buf);
        $this->assertEquals($msgA, $readA);
        $readB = Message::unpack($buf);
        $this->assertEquals($msgB, $readB);
        $readC = Message::unpack($buf);
        $this->assertEquals($msgC, $readC);
        $readD = Message::unpack($buf);
        $this->assertEquals($msgD, $readD);

        $this->assertEquals("", $buf);
    }
}